program Using_units_SVGA256_VESA16_and_VGA256_version_2_1;
{ (c) Matus Horvath, 1991, sjs2@isternet.sk                                  }
uses graph,vesa16;
var gd,gm:integer;
    a:word;
{ From previous versions (not released): you can initialize graphics like this>
    initialize([mode#],[path_to_bgi]);

  You don't have to use INITIALIZE, now you can use also INITGRAPH,
  and now it also detects, which modes you can use. If you place 2 or more 
  units (SVGA256, VESA16, VGA256) to uses, program will detect modes supported 
  by the first unit, if it finds one, it will use it, if not, it will
  try to detect mode supported by the second, etc. If it goes to the end of
  'uses', the standart Pascal detection routine will start and a standart pascal 
  mode will be used. SVGA256 detects VESA/VGA/MCGA cards (ak it doesn't find
  VESA, VGA 320x200x256 will be used), VESA16 detects only VESA, VGA256 only
  VGA/MCGA.

   Example:
    uses VESA16,SVGA256,GRAPH;
  or
    uses VESA16,GRAPH,SVGA256;
  or
    uses GRAPH,VESA16,SVGA256;
    ...
    gd:=detect; initgraph(gd,gm,'');    (searches for VESA compat. card, 
                                         if it is found, and supports any
                                         16-color mode, this mode will be used,
                                         if not, it searches for VGA/MCGA/VESA
                                         256 color modes, if it founds one, it
                                         will be used, if nmot, detects card 
                                         using unit GRAPH. The position of unit 
                                         GRAPH isn't important.
    uses VGA256,VESA16,GRAPH;
    ...
    gd:=detect; initgraph(gd,gm,'');    (in this case, unit VGA256 is first,
                                         so a VGA mode will be allways detected
                                         and unit VESA16 won't be used, because
                                         every VESA card will be detected as
                                         VGA.You should swap VGA256 and VESA16, 
                                         then a VESA modes will be detected first.)

  MaxSVGAMode and MaxVesaMode are highest mode numbers, which will be used.
  The first is for 256 colors and the second for 16 color modes. If
  MaxSVGAMode=2 then mode 2 or lower will be used, even if card supports
  higher mode. (useful when you have a noname monitor like me).
  Default is mode 2 (800x600x256) for SVGA256 and mode 1 (1024x768x16) for
  VESA16. VGA256 doesn't use this variable (it has only one mode).

   Example:
    maxsvgamode:=4       (If a SVGA256 mode is autodetected, it will be
                          from 0 to 4)
    maxvesamode:=2       (If a VESA16 mode is autodetected, it will be
                          form 0 to 2)
                         (Both units must be of course in USES...)
    gd:=detect;
    initgraph(gd,gm,'c:\tp\bgi');

  New constants for mode numbers:
   320x200
    256 f. = 0 = VGA320x200x256
                 ^  ^   ^   ^^^   < this way is the abbreviation made
               = V32256
   640x400
    256 f. = 1 = SVGA640x400x256
               = S63256
                   ^              < the only exeption to the rule above
   640x480
    256 f. = 1 = SVGA640x480x256
               = S64256
   800x600
    16  f. = 0 = SVGA800x600x16
               = S8616;
    256 f. = 2 = SVGA800x600x256
               = S86256;
   1024X768
    16  f. = 1 = SVGA1024x768x16
               = S1716;
    256 f. = 3 = SVGA1024x768x256
               = S17256;
   1280X1024
    16  f. = 2 = SVGA1280x1024x16
               = S1116;

  New "constants" for drivers (they are variables in fact):
   SVGA   = SVGA256 driver
   VESA   = VESA16 driver
   VGA256 = VGA256 driver

  2 more constants
   bgi = 'c:\tp\bgi' <path to bgi
   tp  = 'c:\tp'     <path to tp

  You may use them this way:
   gd:=SVGA; gm:=SVGA800x600x256;
   initgraph(gd,gm,bgi);

   gd:=VESA; gm:=S1716;
   initgraph(gd,gm,bgi);

   (You should use mode (gm) and driver (gd), that have something in common :>,
   eg. VESA and S8616, and not VESA and S86256)

  Then we have also one record, SVGAInfo, in which you can find card info
  (not in VGA256)
   SVGAInfo:record
             VESAVer_Hi:byte;
             VESAVer_Lo:byte;
             (VESA version, eg. version 1.2: VESAVer_Lo:=1; VESAVer_Hi:=2)
             Manufacturer:string;
             (Cad manufacturer)
             Modes:byte;
             (Supported modes:
              bit 0 - 320x200x256
              bit 1 - 640x400x256
              bit 2 - 640x480x256
              bit 3 - 800x600x256
              bit 4 - 1024x768x256
              bit 5 - 800x600x16
              bit 6 - 1024x768x16
              bit 7 - 1280x1024x16

              By the way, the bits in a byte are tested like this
               Is bit 3 in variable X set? => is mode 800x600x256 supported?
               if ((X and 8)=8)then ...(yes) else ...(no)
                8=2^3
               Is bit 6 in variable X set? => is mode 1024x768x16? supported?
               if ((X and 64)=64)then ...(yes) else ...(no)
                64=2^6)
             end;
  Some procedures for faster mode init (faster="less writing").
   I32356             Expalnation of abbreviations: see init constants
   I63256
   I64256
   I86256
   I17256
   I8616
   I1716
   I1116

   Usage:
    uses graph,svga256;
    begin
     i86256;
     line(1,1,getmaxx,getmaxy);   (any graphics)
     closegraph;                  (isn't needed, but should be)
    end.

   Palette edit:
    type DacPalette256 = array[0..255] of array[0..2] of Byte;
    procedure SetVGAPalette(PalBuf:DacPalette256);}

function i2s(x:integer):string; {integer to string}
 var p:string;
 begin
  str(x,p);
  i2s:=p;
 end;

begin
 gd:=detect;
 initgraph(gd,gm,bgi);

 for a:=0 to getmaxx do begin
  setcolor(a mod 255);
  line(a,0,a,getmaxy);
 end;
 setcolor(15);
 outtextxy(1,1,'Mode: '+i2s(getmaxx+1)+'x'+i2s(getmaxy+1)+
               'x'+i2s(getmaxcolor+1));
 readln;
 closegraph;
end.
