{Unit for detecting VGA/VESA cards. The same procedures are used in SVGA256.PAS}
unit svga_ver;
 interface
  type vesainfo=record
                 VESAver_hi:byte;
                 VESAver_lo:byte;
                 Manufacturer:string;
                 modes:byte;
                end;
 function detectvesa(var vi:vesainfo):boolean;

 implementation
  uses crt,strings,dos,mathmh,graph;
  type vmodes=array[1..238]of word;
       infobuffer=record
                   VESAsig:array[1..4]of char;
                   VESAver_hi:byte;
                   VESAver_lo:byte;
                   Manufacturer:pchar;
                   flag:longint;
                   VideoModes:^vmodes;
                   freespace:array[1..119]of word;
                  end;
       p_infobuffer=^infobuffer;
       modeinfobuffer=record
                       modeflag:word;
                       notused1:array[1..16]of byte;
                       xresolution:word;
                       yresolution:word;
                       notused2:array[1..3]of byte;
                       bitesperdot:byte;
                       notused3:array[1..230]of byte;
                      end;
       p_modeinfobuffer=^modeinfobuffer;

 function getvesainfo(var p:infobuffer):boolean;
  var r:registers;
  begin
   r.ah:=$4f;
   r.al:=$00;
   r.es:=seg(p);
   r.di:=ofs(p);
   intr($10,r);
   getvesainfo:=(r.al=$4f)and(r.ah=$00);
  end;

 function getmodeinfo(mode:word;var p:modeinfobuffer):boolean;
  var r:registers;
  begin
   r.ah:=$4f;
   r.al:=$01;
   r.cx:=mode;
   r.es:=seg(p);
   r.di:=ofs(p);
   intr($10,r);
   getmodeinfo:=(r.ah=$00)and(r.al=$4f);
  end;

 function je_to_nas_mod(x,y:word;pmi:modeinfobuffer):boolean;
  begin
   {   X-resolution            Y-resolution              }
   if (pmi.xresolution=x)and(pmi.yresolution=y)and
   {   pocet farieb          graficky mod                }
      (pmi.bitesperdot=8)and((pmi.modeflag and 16)=16)and
   {   farebny mod               monitor je ok           }
      ((pmi.modeflag and 8)=8)and((pmi.modeflag and 1)=1) then
   {  vrati true, ak je to nas mod}
      je_to_nas_mod:=true else je_to_nas_mod:=false;
  end;

 function detectvesa(var vi:vesainfo):boolean;
  var a:word;
      gd,gm:integer;
      pmi:modeinfobuffer;
      pi:infobuffer;
  begin
   vi.modes:=0;
   {Najprv zistime, ci je to aspon VGA alebo MCGA}
   detectgraph(gd,gm);
   if (gd=VGA)or(gd=MCGA) then begin
    vi.modes:=vi.modes or $01;
    {je to VESA?}
    if getvesainfo(pi)and(pi.vesasig[1]+pi.vesasig[2]+pi.vesasig[3]+
                                        pi.vesasig[4]='VESA')then begin
     {je tam nejaka VESA, aka?}
     vi.vesaver_lo:=pi.vesaver_lo;
     vi.vesaver_hi:=pi.vesaver_hi;
     vi.manufacturer:=strpas(pi.manufacturer);

     a:=1;
     {Pre vsetky mody, alebo aspon vsetky do 238}
     while ((a<=238)and(pi.videomodes^[a]<>$ffff)) do begin
      {ak sa ti podari ziskat info o mode,}
      if getmodeinfo(pi.videomodes^[a],pmi) then begin
       {a este k tomu aj info o rozliseni, farbach, usw}
       if (pmi.modeflag and 2)=2 then begin
        {info o rozliseni mame, pouzijeme ho}
        {640x400x256}
        if je_to_nas_mod(640,400,pmi) then vi.modes:=vi.modes or $02;
        {640x480x256}
        if je_to_nas_mod(640,480,pmi) then vi.modes:=vi.modes or $04;
        {800x600x256}
        if je_to_nas_mod(800,600,pmi) then vi.modes:=vi.modes or $08;
        {1024x768x256}
        if je_to_nas_mod(1024,768,pmi) then vi.modes:=vi.modes or $10;
       end else begin
       {info o rozliseni nemame, skusime pouzit cisla modov}
        if pi.videomodes^[a]=$100 then vi.modes:=vi.modes or $02;
        if pi.videomodes^[a]=$101 then vi.modes:=vi.modes or $04;
        if pi.videomodes^[a]=$103 then vi.modes:=vi.modes or $08;
        if pi.videomodes^[a]=$105 then vi.modes:=vi.modes or $10;
       end;
      end;
      inc(a);
     end;
    end else begin {VESA to nie je, ale aspon VGA/MCGA}
     {Nastavime info o karte}
     vi.vesaver_lo:=0;
     vi.vesaver_hi:=0;
     vi.manufacturer:='VGA or MCGA standart';
    end;
    detectvesa:=true
   end else detectvesa:=false; {To nemas ani na VGA?}
  end;
end.